UNIT turtle;
INTERFACE
USES crt,graph;
VAR hd,ortx,orty :real;
    w ,richtung :real;
    up,dw:boolean;
    pfad:string;
PROCEDURE TurtleEin;
PROCEDURE setgraphikpfad(graphikpfad:string);
PROCEDURE getgraphikpfad(VAR graphikpfad:string);
PROCEDURE penup;
PROCEDURE pendown;
PROCEDURE setHeading(w:real);
PROCEDURE getHeading(VAR richtung:real);
PROCEDURE shd(w:real);
PROCEDURE forwd(n:real);
PROCEDURE back(n:real);
PROCEDURE turnleft(w:real);
PROCEDURE turnright(w:real);
PROCEDURE home;
PROCEDURE mitte;
PROCEDURE pu;
PROCEDURE pd;
PROCEDURE fd(n:real);
PROCEDURE bk(n:real);
PROCEDURE lt(w:real);
PROCEDURE rt(w:real);
PROCEDURE cs;

IMPLEMENTATION
PROCEDURE setgraphikpfad;
  begin  pfad:=graphikpfad;
  END;
PROCEDURE getgraphikpfad;
  begin graphikpfad:=pfad;
  end;

PROCEDURE TurtleEin;
  VAR gd,gm:integer;
  begin
    detectgraph(gd,gm);
    initGraph(gd,gm,pfad);
    hd:=0; {Richtung  x-Achse, nach rechts}
    up:=false; dw:=true;{pendown}
  end;

PROCEDURE penup;
 begin up:=true; dw:=false; end;
PROCEDURE pendown;
 begin up:=false; dw:=true; end;


PROCEDURE setHeading;
 begin
   w:=w-trunc(w/360)*360;
   hd:=w;
 end;

PROCEDURE getHeading;
 begin
   richtung:=hd;
 end;

PROCEDURE shd;  begin setheading(w);end;

PROCEDURE forwd;
 VAR dx,dy:longint;
 begin
  dx:=round(n*cos(hd*pi/180));
  dy:=round(n*sin(hd*pi/180));
  if dw then lineRel(dx,dy);
  if up then moveRel(dx,dy);
 END;
PROCEDURE back;
 VAR dx,dy:longint;
 begin
  hd:=hd+180;
  dx:=round(n*cos(hd*pi/180));
  dy:=round(n*sin(hd*pi/180));
  if dw then lineRel(dx,dy);
  if up then moveRel(dx,dy);
  hd:=hd-180;
 END;

PROCEDURE turnleft;  begin setHeading(hd-w); end;
PROCEDURE turnright; begin setHeading(hd+w); end;
PROCEDURE home;
  begin ortx:=0; orty:=0;{moveto(0,0);}setheading(0); end;
PROCEDURE mitte;
  begin moveto(360,174); setheading(0);end;
PROCEDURE pu;           begin penup;end;
PROCEDURE pd;           begin pendown;end;
PROCEDURE fd;           begin forwd(n);end;
PROCEDURE bk;           begin back(n);end;
PROCEDURE lt;           begin turnleft(w);end;
PROCEDURE rt;           begin turnright(w);end;
PROCEDURE cs;           begin clearviewport;home; end;
BEGIN
    pfad:='';
END.