program kegelschnitte;
{b:keglschn.pas ha 25.1.92 und 5.10.93 mit der edlen Eingabe}
{die Exeversion fr FH ist ohne Math-Proz.}
uses crt,graph,turtle,printer,scrcopy;
var pc,i,j,alpha,tempo,x,y,maxx,maxy,mitx,mity:integer;
    urx,ury,pixx,pixxur,pixy,pixyur,fy:integer;
    achsendarstellung,ant,antw,antfkt,graphikdruck:char;
    xr,yr,z,e,a,b,aa,bb,p,s,t,fak,xm,ym,fakx,faky,li,re,ob,unt:real;
    Hintergrundfarbe,Stiftfarbe,Achsenfarbe:integer;

PROCEDURE ueberschrift;
begin
  clrscr;
  repeat
    writeln('        ************************************************');
    writeln('        *                                              *');
    writeln('        *         K e g e l s c h n i t t e            *');
    writeln('        *                   und                        *');
    writeln('        *             Relationenscharen                *');
    writeln('        *                                              *');
    writeln('        ************************************************');
    writeln('        *  Demonstration verschiedener Kegelschnitt-   *');
    writeln('        *  konstruktionen:                             *');
    writeln('        *  Interferenzhyperbeln, ...                   *');
    writeln('        *  Ellipse in Stangen- und Fadenkonstruktion   *');
    writeln('        *  Parabel in Leitgeradenkonstuktion           *');
    writeln('        *  Reflexionsphnomene...                      *');
    writeln('        ************************************************');
    writeln('        *                                              *');
    writeln('        *  Pascal-Entwicklungsumgebung fr Scharen     *');
    writeln('        *  von Relationen und Funktionen               *');
    writeln('        *                                              *');
    writeln('        *  Dr.Drte Haftendorn Johanneum Lneburg 1992 *');
    writeln('        *                                              *');
    writeln('        ************************************************');
    writeln('        * Falls nur ein sw-Monitor vorliegt       <s>  *');
    writeln('        *                     sonst Taste    drcken  *');
    ant:=readkey;
  until ord(ant)<>0;
  if ant='s' then PC:=0;
end;{ueberschrift}

{######################################Readprozeduren##############}
{Komfortable Prozeduren, die mit   eine Einstellung fr x }
{beibehalten und sie bei anderen Tasten entsprechend ndern.}
{Lschen mit der Rcktaste,  nicht mit Entfernen !!}
{ Version 3/95 , bei der man auch den 1. Buchstaben lschen kann.}
              { es ist eine Eingabesicherung  vorhanden.}
{readint(x),readreal(x,v,d),readstring(x)
                                        mit Eingabeaufforderung}

PROCEDURE hintenweg(VAR x:string);
var i,l:integer;
   hilf:string;
begin   l:=length(x);  hilf:='';
  for i:=1 to l-1 do
    hilf:=hilf+x[i];
    x:=hilf;
end;
Procedure belege(taste:char;VAR strvari:string);
var hinein:boolean;
begin
     if taste <>#8 then hinein:=true else hinein:=false;
     strvari:='';
     repeat
       if hinein then begin
         write(taste);
         strvari:=strvari +Taste;
       end;
       taste:=readkey;
       hinein:=true;
       if taste=#8 then begin
             hinein:=false;gotoxy(wherex-1,wherey);
             write(' ');gotoxy(wherex-1,wherey);
             hintenweg(strvari);end;
     until    ord(taste)=13;
end;
Procedure readint(VAR x:integer);
  var code:integer;
       taste:char;
     strvari:string;
  begin
    code:=0;
    write('Es gilt ',x,' ');
    repeat
      write(', bitte neue Integer-Zahl   ');
      if code=0 then write('oder    ');
      if code<>0 then
           begin sound(220);delay(200);nosound; end;
      taste:=readkey;
      if ord(taste)<>13 then begin
         belege(taste,strvari);
         val(strvari,x,code);
         writeln;
      end;
     until code=0;
end;  {Procedure readint(x)}

Procedure readreal(VAR x:real;v,d:integer);
{ behlt mit   eine Einstellung fr x bei ndert sie bei Neueingabe.}
  var   code:integer;
       taste:char;
     strvari:string;
  begin
    write('Es gilt ',x:v:d,' ');
    code:=0;
    repeat
      write(', bitte neue real-Zahl   ');
      if code=0 then write('oder    ');
      if code<>0 then
           begin sound(220);delay(200);nosound; end;
      taste:=readkey;
      if ord(taste)<>13 then begin
         belege(taste,strvari);
         val(strvari,x,code);
         writeln;
      end;
     until code=0;
  end;  {procedure readreal(x)}

{########## Ende der neuen Read-Prozeduren }
function scxinv(screenx:integer):real; forward;
function scyinv(screeny:integer):real; forward;
PROCEDURE vorgaben;
begin
  PC:=1; {fr PC, falls nur XT setze PC:=0;}
  maxx:=getmaxx ;maxy:=getmaxy;
  mitx:=maxx div 2+1;mity:=maxy div 2+1;
  urx:=mitx;ury:=mity;pixxur:=20 ;pixyur:=20;fy:=-1;
  pixx:=pixxur;pixy:=pixyur;
  fakx:=1; faky:=1;
  a:=15;b:=8;p:=3;fak:=1/2/p;xm:=0;ym:=0;
  achsendarstellung:='1';antfkt:='l';
  Hintergrundfarbe:=0;
  Stiftfarbe:=15;
  Achsenfarbe:=2;
  tempo:=100;
  graphikdruck:='n';
end;{vorgaben}
procedure fensterneu;
   begin
        li:=scxinv(0);re:=scxinv(getmaxx);
        unt:=scyinv(getmaxy); ob:=scyinv(0);
   end;
PROCEDURE parameterveraendern;
begin
    writeln('Fr die Relationen mit den Optionen l,h,,f,p,q');
    writeln('------------------------------------------------------------');
    writeln('empfohlen fr die Ellipsen <f> und <g>  (0,0)   a=15,   b=8 ');
    writeln('empfohlen fr Parabeln     <p> und <q>  (0/0) , p=3');
    writeln('empfohlen fr aufrechte Parabel    <a> (0/-8) , p=6');
    writeln('diese erfordern gleiche Einheit in x-und y-Richtung');
    writeln('------------------------------------------------------------');
    writeln('Fr die Ellipse <l> und die Hyperbel <h> ist alles frei whlbar.');
    writeln;
    write('groe  Halbachse a : ');readreal(a,2,2);writeln;
    write('kleine Halbachse b : ');readreal(b,2,2);writeln;
    writeln;
    writeln('Parabelffnungsfaktor nach oben 1/(2p) nach rechts 2p');
    write('Parabelparameter p : ');readreal(p,2,2);writeln;
    fak:=1/2/p;
    writeln('Scheitel- bzw.  Mittelpunkt ');
    write(' x-Koordinate  : ');readreal(xm,2,2);writeln;
    write(' y-Koordinate  : ');readreal(ym,2,2);writeln;
 end;{parameterverndern}

PROCEDURE farben;
begin
  writeln('Als Farbnummern stehen 0 bis 15 zur Verfgung.');
  writeln('0=Schwarz          4=rot        8=dunk.grau      12=rosa');
  writeln('1=blau             5=lila       9=hellblau       13=pink');
  writeln('2=grn             6=ocker     10=hellgrn       14=gelb');
  writeln('3=trkis           7=hellgrau  11=lichtblau      15=wei');
  writeln;
  writeln('Farben fr Schwarzwei-Druck sind Hint.0, Stift 15, Achse 15  ');
  writeln('Anfangsbelegung            Hintergrung 6, Stift 15, Achsen  2' );
  writeln;
  write('Hintergrundfarbe: ');readint(Hintergrundfarbe);writeln;
  writeln;
  write('Zeichenfarbe    : ');readint(Stiftfarbe);writeln;
  writeln;
  write('Achsenfarbe     : ');readint(Achsenfarbe);writeln;
  writeln;
  writeln;
  writeln;
end;

{_________Umrechnung der Koordinaten_______________}
function scx(x:integer):integer;
  begin scx:=urx+x*pixx; end;
function scy(y:integer):integer;
  begin scy:=ury+fy*y*pixy; end;
function scxr(xr:real):integer;
  begin scxr:=round(urx+xr*pixx); end;
function scyr(yr:real):integer;
  begin scyr:=round(ury+fy*yr*pixy); end;
function scxinv(screenx:integer):real;
  begin scxinv:=(screenx-urx)/pixx; end;
function scyinv(screeny:integer):real;
  begin scyinv:=(screeny-ury)/(fy*pixy); end;
{__________________________________________________}
procedure koordinatensystem;
begin
writeln;
writeln;writeln;
while ant='a' do begin
  clrscr;
  writeln('**************Koordinatensystem einrichten*************');
  writeln;
  writeln('Der Graphikbildschirm hat in x-Richtung  ',maxx,' Punkte');
  writeln('Der Graphikbildschirm hat in y-Richtung  ',maxy,' Punkte') ;
  writeln('Die Lage des Koordinatenurpsrungs ist  ( ',urx,' / ',ury,' )');
  writeln('In x-Richtung entspricht eine Einheit  ',pixx,' Punkten.');
  writeln('In y-Richtung entspricht eine Einheit  ',pixy,' Punkten.') ;
  writeln('Die y-Achse zeigt nach oben.');
  writeln('_______________M E N U_______________________');
  writeln('Neue Urprungskoordinaten absolut       < 1 > ');
  writeln('Wahl des sichtbaren Fensters           < 2 > ');
  writeln('Skalierung: mit Faktoren der Einheit   < 3 > ');
  writeln('Skalierung: absolutin Punkten/Einheit  < 4 > ');
  writeln('Richtung der y-Achse ndern            < 5 > ');
  writeln('Darstellung des Achsenkreuzes          < 6 > ');
  writeln('Farben ndern und evt. Edeldruck       < 7 > ');
  writeln('Tempo der Zeichnung ndern             < 8 > ');
  writeln('Parameter verndern                    < 9 > ');
  writeln('_____________________________________________');
  writeln;
  writeln('nichts weiter ndern                   <  > ');
    antw:=readkey;
  clrscr;
  case antw of
  '1':begin
        writeln('Der Graphikbildschirm hat in x-Richtung  ',maxx,' Punkte');
        writeln('Der Graphikbildschirm hat in y-Richtung  ',maxy,' Punkte') ;
        writeln;
        writeln('Als Mitte gilt  ( ',mitx,' / ',mity,' ).');
        writeln;
        writeln('Momentan gilt absolut: Ursprung( ',urx,' / ',ury,' )');
        writeln;
        write('Urprung x absolut : ');readint(urx); writeln;
        write('Urprung y absolut : ');readint(ury); writeln;
        fensterneu;
      end;
  '2':begin
        writeln('Das sichtbare Fenster in Einheiten : ');
        writeln('in x-Richtung:',scxinv(0):3:3,' bis ',scxinv(getmaxx):3:3);
        if fy=1 then begin
            writeln('in y-Richtung:',scyinv(0):3:3,
                             ' bis ',scyinv(getmaxy):3:3);
            writeln('Die y-Achse zeigt nach unten.');
          end
        else begin
            writeln('in y-Richtung:',scyinv(getmaxy):3:3,
                             ' bis ',scyinv(0):3:3);
            writeln('Die y-Achse zeigt nach oben.');
          end;
       writeln;
        writeln('Fenster in x-Richtung-Einheiten : ');
        write('links von   : ');readreal(li,2,3); writeln;
        write('bis rechts  : ');readreal(re,2,3); writeln;
       writeln;
        writeln('Fenster in y-Richtung-Einheiten : ');
        if fy=-1 then begin
            write('unten von   : ');readreal(unt,2,3); writeln;
            write('bis oben    : ');readreal(ob,2,3); writeln;
            fy:=-1;
          end
        else begin
            write('oben von   : ');readreal(ob,2,3); writeln;
            write('bis unten  : ');readreal(unt,2,3); writeln;
            fy:=1;
        end;
        pixx:=round(getmaxx/(re-li));
        pixy:=round(getmaxy/abs(ob-unt));
        fakx:=pixx/pixxur;
        faky:=pixy/pixyur;        urx:=round(-pixx*li);
        if fy=-1 then
           ury:=round(getmaxy+pixy*unt)
        else
           ury:=round(-pixy*ob);
      end;
  '3':begin
        writeln('Der Graphikbildschirm hat in x-Richtung  ',maxx,' Punkte');
        writeln('Der Graphikbildschirm hat in y-Richtung  ',maxy,' Punkte') ;
        writeln;
        writeln('Ursprngliche Belegung :');
        writeln('              ',pixxur,' Pixel/Einheit     in beiden Richtungen.');
        writeln('Momentan gilt: ');
        writeln('in x-Richtung: ',pixx,' pro Einheit ');
        writeln('in y-Richtung: ',pixy,' pro Einheit');
        writeln;
        writeln('Es wird gerechnet :  ursprngliche Pixel/Einheit * Faktor');
        writeln('             Also :    Pixel/Einheit = ',pixxur,' * Faktor');
        writeln;
        writeln;
        writeln('Skalierung: ');
        write('Faktor in x-Richtung : ');readreal(fakx,4,3); writeln;
        write('Faktor in y-Richtung : ');readreal(faky,4,3); writeln;
        pixx:=round(pixxur*fakx); pixy:=round(faky*pixyur);
        fensterneu;
      end;
  '4':begin
        writeln('Der Graphikbildschirm hat in x-Richtung  ',maxx,' Punkte');
        writeln('Der Graphikbildschirm hat in y-Richtung  ',maxy,' Punkte') ;
        writeln('Ursprngliche Einheit = ',pixxur,' Pixel in beiden Richtungen.');
        writeln;
        writeln('Momentan gilt: x-Richtung: ',pixx,'/Einheit ');
        writeln('               y-Richtung: ',pixx,'/Einheit ');
        writeln;
        writeln;
        writeln('Pixel, die eine Einheit bedeuten sollen:  ');
        writeln('in x-Richtung : ');readint(pixx); writeln;
        writeln('in y-Richtung : ');readint(pixy); writeln;
        fakx:=pixx/pixxur;faky:=pixy/pixyur;
        fensterneu;
      end;
  '5':begin
       writeln;
        writeln;
        write('Momentan zeigt die y-Achse nach ');
        if fy=1 then writeln('unten.') else writeln('oben.');
        writeln;
        writeln('So soll es bleiben           <>' );
        writeln('Sie soll umgedreht werden    <u>' );
        repeat
          ant:=readkey;
          if ant='u' then fy:=fy*(-1);
        until (ord(ant)=13) or (ant='u');
        fensterneu;
      end;
  '6':begin
        writeln('Die Achsen sollen ganz  dargestellt werden. <1>');
        writeln('Die Achsen sollen halb  dargestellt werden. <2>');
        writeln('Die Achsen sollen nicht dargestellt werden. <3>');
        writeln;
        writeln('Gewhlt ist ',achsendarstellung);
        writeln('Einstellung beibehalten                     <>');
        repeat
          antw:=readkey;
        until (antw in ['1','2','3']) or  (ord(antw)=13);
        if antw in ['1','2','3'] then achsendarstellung:=antw;
       end; {of 6}
   '7':begin farben;
             writeln('  Druck der nchsten Graphik ');
             writeln('Edelversion ohne das Wort DRUCK       <d>');
             writeln('');
             writeln('Druck evt. spter whlen              <>');
             antw:=readkey;
             if antw='d' then graphikdruck:='d'
               else graphikdruck:='n';
      end;
   '8':begin
       writeln('Wenn der Computer zu schnell zeichnet,kann er gebremst werden.');
       writeln;
       writeln('Wenn der Computer zu langsam zeichnet,whle 0 und fasse dich in Geduld.');
       writeln;
       writeln('Eben war die Verzgerungszeit ',tempo,' Millisekunden ');
       writeln;
       write('Verzgerungszeit : ');readint(tempo); writeln;
       end;
   '9':parameterveraendern;
    end; { end of case gro }
    if (antw in ['1'..'9']) then ant:='a'else ant:='z';
  end;{while}
end;{koordinatensystem}

PROCEDURE achsenzeichnen;
var einheiten,start:integer;
begin
  setbkcolor(Hintergrundfarbe);
  setcolor(Achsenfarbe);
  case achsendarstellung of
  '1':begin line(0,ury,maxx,ury);
            line(urx,0,urx,maxy);
            einheiten:=urx div pixx;
            start:=urx-einheiten*pixx;
            for i:=0 to maxx div pixx do
              line(start+i*pixx,ury,start+i*pixx,ury+fy*5);
            einheiten:=ury div pixy;
            start:=ury-einheiten*pixy;
            for i:=0 to maxy div pixy do
              line(urx,start+i*pixy,urx+5,start+i*pixy);
      end;
  '2':begin
        line(urx,ury,maxx,ury);
        line(urx,ury,urx,(maxy+fy*maxy)div 2);
        for i:=0 to maxx div pixx do
          line(urx+i*pixx,ury,urx+i*pixx,ury+fy*5);
        for i:=0 to maxx div pixx do
          line(urx,ury+fy*i*pixy,urx+5,ury+fy*i*pixy);
      end;
  '3':begin
      end;
  end; {end of case}
  setcolor(Stiftfarbe);
end;{achsenzeichnen}

{-----FUNKTIONEN---------------------------------------------------}

PROCEDURE sinus;  {als PROTOTYP fr eine einfache Fkt.}
begin
  xr:=-15; yr:=10*sin(xr); moveto(scxr(xr),scyr(yr));
  repeat
    xr:=xr+0.01; yr:=10*sin(xr);
    lineto(scxr(xr),scyr(yr));
  until xr>=15;
END{sinus};
{--------------------------------------------------------}
PROCEDURE zeichne_relation;  {als PROTOTYP fr eine Relation }
var xi:integer;
FUNCTION f(xr,yr:real):real;
begin
  if xr*yr<>0 then
  f:= xr*yr/(sqr(xr)+sqr(yr));
end;{ f }
begin
  xr:=scxr(0); yr:=f(xr,yr);
  moveto(0,scyr(yr));
  for xi:=0 to maxx do begin
    xr:=scxinv(xi);
    yr:=f(xr,yr);
    lineto(xi,scyr(yr));
  end;
END ;{zeichne_relation}
{--------------------------------------------------------}
{rrrr}
PROCEDURE zeichne_ringe;  {als PROTOTYP fr eine Relation }
var xi,yi,farbe:integer;
FUNCTION f(xr,yr:real):real;
begin
{ if(xr<>0) or (yr<>0) then              }
{  f:= xr*yr*(sqr(xr)-sqr(yr))/(sqr(xr)+sqr(yr))} {8-stahlig}
{  f:= xr*yr*(sqr(cos(xr))-sqr(yr))/(sqr(xr)+sqr(yr))}   {wellig ohne Punkte}
{  f:= (xr+cos(yr))*(yr+sin(xr))                       } {marmoriert}
{  f:= cos(xr*xr)+sqr(yr*xr)                       } {Kullerkreuz}
  f:= sqr(sin(xr))+sqr(yr)                       {wellig mit Punkten}

{  else f:=0;}
end;{ f }
begin
  for xi:=0 to maxx do
    for yi:=0 to maxy do begin
      farbe:=15 +( round(abs(f(scxinv(xi),scyinv(yi)))) mod 2);
      putpixel(xi,yi,farbe);
  end;
END ;{zeichne_ringe}
{--------------------------------------------------------}
PROCEDURE wurzelparabel(xm,ym,fak:real);
begin
  xr:=xm; yr:=ym; moveto(scxr(xr),scyr(yr));
  repeat
    yr:=yr+0.01; xr:=fak*(yr-ym)*(yr-ym)+xm;
    lineto(scxr(xr),scyr(yr));
  until yr>=15;
  xr:=xm; yr:=ym; moveto(scxr(xr),scyr(yr));
  repeat
    yr:=yr-0.01; xr:=fak*(yr-ym)*(yr-ym)+xm;
    lineto(scxr(xr),scyr(yr));
  until yr<=-15;
END{wurzelparabel};
{--------------------------------------------------------}
PROCEDURE parabel(xm,ym,fak:real);
begin
  xr:=xm; yr:=ym; moveto(scxr(xr),scyr(yr));
  repeat
    xr:=xr+0.01; yr:=fak*(xr-xm)*(xr-xm)+ym;
    lineto(scxr(xr),scyr(yr));
  until xr>=15;
  xr:=xm; yr:=ym; moveto(scxr(xr),scyr(yr));
  repeat
    xr:=xr-0.01; yr:=fak*(xr-xm)*(xr-xm)+ym;
    lineto(scxr(xr),scyr(yr));
  until xr<=-15;
END{parabel};
{--------------------------------------------------------}

PROCEDURE konzentr_Kreise(e:real);
begin              setcolor(stiftfarbe-PC);
   for i:=1 to 22 do begin
     ellipse(scxr(-round(e)),scyr(0),0,360,(pixx*i)div 2,(pixx*i)div 2 );end;
   for i:=1 to 22 do begin ellipse(scxr(round(e)),scyr(0),0,360,(pixx*i)div 2,(pixx*i)div 2 );end;
    setcolor(Stiftfarbe); 
END{konzentr_Kreise};
{--------------------------------------------------------}
PROCEDURE hyperbel(xm,ym,a,b:real);
var urx_alt,ury_alt:integer;
begin
  urx_alt:=urx;  ury_alt:=ury;
  urx:=scxr(xm);  ury:=scyr(ym);
  xr:=a; yr:=0; moveto(scxr(xr),scyr(yr));
  repeat
    xr:=xr+0.01; yr:=b*sqrt(xr*xr/a/a-1);
    lineto(scxr(xr),scyr(yr));
  until scxr(xr)>=maxx;
  xr:=a; yr:=0; moveto(scxr(xr),scyr(yr));
  repeat
    xr:=xr+0.01; yr:=-b*sqrt(xr*xr/a/a-1);
    lineto(scxr(xr),scyr(yr));
  until scxr(xr)>=maxx;
  xr:=-a; yr:=0; moveto(scxr(xr),scyr(yr));
  repeat
    xr:=xr-0.01; yr:=b*sqrt(xr*xr/a/a-1);
    lineto(scxr(xr),scyr(yr));
  until scxr(xr)<=0;
  xr:=-a; yr:=0; moveto(scxr(xr),scyr(yr));
  repeat
    xr:=xr-0.01; yr:=-b*sqrt(xr*xr/a/a-1);
    lineto(scxr(xr),scyr(yr));
  until scxr(xr)<=0;
  urx:=urx_alt; ury:= ury_alt;
END{hyperbel};
{--------------------------------------------------------}
PROCEDURE hyperbel_faden_echt;
var aalt,balt:real;
  begin {Hyperbelfadenkonstruktion echt}
        aalt:=a; balt:=b;
        a:=5;b:=3;
        e:=sqrt(a*a+b*b);
        alpha:=0;
        repeat
          z:=(b*b/(a+e*cos(alpha*3.1416/180)));
          moveto(scxr(-e),scyr(0));
          fd(round(z*pixx));
          lineto(scxr(e),scyr(0));delay(tempo);
          alpha:=alpha+12;
          lt(12);
        until alpha>=360;
        alpha:=0;
        lt(180);
        repeat
          z:=(b*b/(a+e*cos(alpha*3.1416/180)));
          moveto(scxr(e),scyr(0));
          fd(round(z*pixx));
          lineto(scxr(-e),scyr(0));delay(tempo);
          alpha:=alpha+12;
          lt(12);
        until alpha>=360;
        setcolor(Stiftfarbe-PC);
        hyperbel(0,0,a,b);
        setcolor(Stiftfarbe);
        a:=aalt;b:=balt;
     end;
{--------------------------------------------------------}
PROCEDURE ellipsesc(xm,ym,a,b:real);  {sc= screen}
begin
  ellipse(scxr(xm),scyr(ym),0,360,round(a*pixx),round(b*pixy));
END{ellipsesc};
{--------------------------------------------------------}
PROCEDURE  ellipse_stangen;
var aalt,balt:real;
  begin mitte;
     aalt:=a; balt:=b;
     a:=8;b:=4;
     t:=a+b-0.5;
     repeat {neue Gerade festlegen}
        s:=sqrt((a+b)*(a+b)-t*t);
        yr:=t;
        moveto(scxr(0),scyr(yr));
          repeat  {neue Gerade zeichen}
          yr:=yr-0.1;
          xr:=s-s/t*yr;
          lineto(scxr(xr),scyr(yr));
        until xr> s;
        delay(tempo);
        yr:=b/(a+b)*t;
        xr:=a/(a+b)*s;
        setcolor(Stiftfarbe+PC*5);
          circle(scxr(xr),scyr(yr),5);
        setcolor(Stiftfarbe);
        t:=t-0.5;
      until t<=0;
      {----------II Quadrant-----}
      t:=a+b-0.5;
     repeat {neue Gerade festlegen}
        s:=-sqrt((a+b)*(a+b)-t*t);
        yr:=t;
        moveto(scxr(0),scyr(yr));
          repeat  {neue Gerade zeichen}
          yr:=yr-0.1;
          xr:=s-s/t*yr;
          lineto(scxr(xr),scyr(yr));
        until xr< s;
        delay(tempo);
        yr:=b/(a+b)*t;
        xr:=a/(a+b)*s;
        setcolor(Stiftfarbe+PC*5);
          circle(scxr(xr),scyr(yr),5);
        setcolor(Stiftfarbe);
        t:=t-0.5;
      until t<=0;
      {-----------III Quadrant-------}
      t:=-(a+b-0.5);
     repeat {neue Gerade festlegen}
        s:=-sqrt((a+b)*(a+b)-t*t);
        yr:=t;
        moveto(scxr(0),scyr(yr));
          repeat  {neue Gerade zeichen}
          yr:=yr+0.1;
          xr:=s-s/t*yr;
          lineto(scxr(xr),scyr(yr));
        until xr< s;
        delay(tempo);
        yr:=b/(a+b)*t;
        xr:=a/(a+b)*s;
        setcolor(Stiftfarbe+PC*5);
          circle(scxr(xr),scyr(yr),5);
        setcolor(Stiftfarbe);
        t:=t+0.5;
      until t>=0;
      {------------IV Quadrant--------}
      t:=-(a+b-0.5);
     repeat {neue Gerade festlegen}
        s:=sqrt((a+b)*(a+b)-t*t);
        yr:=t;
        moveto(scxr(0),scyr(yr));
          repeat  {neue Gerade zeichen}
          yr:=yr+0.1;
          xr:=s-s/t*yr;
          lineto(scxr(xr),scyr(yr));
        until xr> s;
        delay(tempo);
        yr:=b/(a+b)*t;
        xr:=a/(a+b)*s;
        setcolor(Stiftfarbe+PC*5);
          circle(scxr(xr),scyr(yr),5);
        setcolor(Stiftfarbe);
        t:=t+0.5;
      until t>=0;
      delay(2000);
      setcolor(Stiftfarbe-PC);
        ellipsesc(0,0,a,b);
      setcolor(Stiftfarbe);
      a:=aalt;b:=balt;
    end{ellipse_stangen};
{--------------------------------------------------------}
PROCEDURE gaertner_unecht;
  begin {Grtnerkonstruktion aber "unecht" gezeichnet}
    e:=sqrt(abs(a*a-b*b));
    xr:=-a;
    repeat
      yr:=b*sqrt(1-xr*xr/a/a);
      moveto(scxr(-e),scyr(0));
      lineto(scxr(xr),scyr(yr));
      lineto(scxr(e),scyr(0));
      xr:=xr+0.5;
      delay(tempo);
    until xr>a;
    xr:=-a;
    repeat
      yr:=-b*sqrt(1-xr*xr/a/a);
      moveto(scxr(-e),scyr(0));
      lineto(scxr(xr),scyr(yr));
      lineto(scxr(e),scyr(0));
      xr:=xr+0.5;
      delay(tempo);
    until xr>a;
    delay(2000);
    setcolor(Stiftfarbe-PC);
      ellipsesc(0,0,a,b);
    setcolor(Stiftfarbe);
  end;{gaertner_unecht}
{--------------------------------------------------------}
PROCEDURE ellipse_faden_echt;
  begin {fadenkonstruktion wirklich}
    e:=sqrt(abs(a*a-b*b));
    alpha:=0;
    repeat
      z:=(b*b/(a-e*cos(alpha*3.1416/180)));
      moveto(scxr(-e),scyr(0));
      fd(round(z*pixx));
      lineto(scxr(e),scyr(0));delay(tempo);
      alpha:=alpha+5;
      lt(5);
      delay(tempo);
    until alpha>=360;
    setcolor(Stiftfarbe-PC);
      ellipsesc(0,0,a,b);
    setcolor(Stiftfarbe);
 end;{Ellipse_faden_echt}
{--------------------------------------------------------}
PROCEDURE parabel_leitgerade;
var k:real;
  begin
    urx:=urx+pixx*(-10);
    line(scxr(-p/2),0,scxr(-p/2),maxy);{Leitgerade}
    alpha:=30;
    lt(alpha);
    repeat
      z:=p/(1-cos(alpha*3.1416/180));
      moveto(scxr(p/2),scyr(0));{start im Brennpunkt}
      fd(round(z*pixx));
      lineto(scxr(-p/2),gety);delay(tempo);
      alpha:=alpha+5;
      lt(5);
    until alpha>=331;
    urx:=urx+pixx*(+10);
    delay(5*tempo);
    setcolor(Stiftfarbe-PC);
    wurzelparabel(-10,0,1/2/p);
    setcolor(Stiftfarbe);
 end;{parabel_leitgerade}
{--------------------------------------------------------}
PROCEDURE parabel_huelle;
{Tangenten sind die Mittelsenktrechten aus der Leitgeradenkonstr.}
var k,beta:real;
  begin
    urx:=urx+pixx*(-10);
    setcolor(Stiftfarbe+PC*5);
    line(scxr(-p/2),0,scxr(-p/2),maxy);{Leitgerade}
    setcolor(Stiftfarbe);
    beta:=75;
    lt(105);
    repeat
      k:=p/(cos(beta*3.1416/180));
      moveto(scxr(p/2),scyr(0));{start im Brennpunkt}
      fd(round(k*pixx));bk(round(k/2*pixx));rt(90);fd(20*pixx);bk(40*pixx);
      beta:=beta-5;delay(tempo);
      lt(95);
    until beta<=-76;
    urx:=urx+pixx*(+10);
      readln;
      setcolor(Stiftfarbe-PC);
      wurzelparabel(-10,0,1/2/p);
      setcolor(Stiftfarbe);
  end{parabel_huelle};
{--------------------------------------------------------}
PROCEDURE parabelreflexion;
  begin
      ury:=ury+pixy*(10);
      setcolor(Stiftfarbe-PC);
      parabel(xm,ym,fak);
      setcolor(Stiftfarbe);
      alpha:=60;
      lt(alpha+(1+fy)*90);
      repeat
        z:=p/(1-sin(alpha*3.1416/180));
        moveto(scxr(xm),scyr(ym+p/2));{start im Brennpunkt}
        fd(round(z*pixy));
        lineto(getx,round(maxy+fy*p*maxy/abs(p)));delay(tempo);
        alpha:=alpha-10;
        rt(10);
      until alpha<=-241;
      ury:=ury-pixy*(10);
    end;
{--------------------------------------------------------}

PROCEDURE funktionswahl;
  begin
    writeln('Vorrat an Funktionen:');
    writeln('-------------------------------------------');
    writeln('Sinus                                   <s>');
    writeln('Muster aus Ringen                       <r>');
    writeln('konzentrische Kreise                    <k>');
    writeln('Hyperbeln, alle                         <y>');
    writeln('konzentrische Kreise mit Hyperbeln      <z>');
    writeln('Hyperbel Fadenkonstruktion              <w>');
    writeln('Hyperbel                                <h>');
    writeln('Ellipse                                 <l>');
    writeln('Ellipse Stangenkonstruktion a=8,b=4     <t>');
    writeln('Ellipse Grtnerkonstruktion(unecht)     <g>');
    writeln('Ellipse Fadenkonstruktion  (echt)       <f>');
    writeln('Parabel Leitgeradenkonstruktion         <p>');
    writeln('Parabel Hllkonstruktion                <q>');
    writeln('Parabel mit Reflexion (aufrecht)        <a>');
    writeln;
    writeln('-------------------------------------------');
    writeln('Programm  beenden                       <e>');
    antfkt:=readkey;

  end;{funktionswahl, bergibt antfkt}

{--------------------------------------------------------}
{ +++++++++++++++++++++++Hauptprogramm+++++++++++++++++++++++++++++++++ }
begin
turtleein;
vorgaben;
fensterneu;
closegraph;
ueberschrift;
repeat
  ant:='a';
  koordinatensystem;
  funktionswahl;
  turtleein;
  if antfkt<>'e'then achsenzeichnen;
  {**********Platz zum Einbau von Funktionen*******************************
  Die Funktionsterme sind normal zu schreiben.
  Dabei sind x,y integer  und xr, yr real vereinbart.
  Dann sind die Koordinaten im Integerfall mit scx(x) und scy(y)
            im Realfall    mit scxr(xr) und scyr(yr) umzurechnen.
  Beispiel: statt plot(x,sin(x))  mu stehen plot(scxr(xr)),scyr(sin(xr))
            oder  yr:= sin(xr) und dann lineto(scxr(xr),scyr(yr));
  **********Platz zum Einbau von Funktionen***** sc=screen *************** }
  case antfkt of
    's':begin sinus;
        end;
    'r':begin zeichne_ringe; end;
    'k':begin e:=4;  konzentr_Kreise(e);
        end;
    'y':begin
          e:=4;i:=1;a:=i/2;
          repeat
            b:=sqrt(e*e-a*a);
            hyperbel(0,0,a,b);
            i:=i+1;
            a:=i/2;
          until e*e-a*a<=0
        end;
    'z':begin
          e:=4;aa:=a; bb:=b;
          konzentr_Kreise(e);
          i:=1;aa:=i/2;
          repeat
            bb:=sqrt(e*e-aa*aa);
            hyperbel(0,0,aa,bb);
            i:=i+1;
            aa:=i/2;
          until e*e-aa*aa<=0;
        end;
    'w':hyperbel_faden_echt;
    'l':ellipsesc(xm,ym,a,b);
    'h':hyperbel(xm,ym,a/3,b/3);
    't':ellipse_stangen;
    'g':gaertner_unecht;
    'f':ellipse_faden_echt;
    'p':parabel_leitgerade;
    'q':parabel_huelle;
    'a':parabelreflexion;
  end; {end of case}
  {*****************************************************************}
  if antfkt<>'e' then begin
    readln;
    if graphikdruck='d' then hardcopy(false)
       {so kann die Gaphik ohne das wort DRUCK gedruckt werden}
    else begin
     outtextxy(10,getmaxy-10,'Druck <d>   weiter  ');
     antw:=readkey;
     case antw of
       'd': hardcopy(false);
     end{case};
    end;
  end;
  closegraph;
until antfkt='e';
end.
